//DeweyAttractor Color
color col = color(204,51,0);
      
class Matrix 
{
  ArrayList<DeweyAttractor> deweyAttractor = new ArrayList<DeweyAttractor>();
      
  void setupDeweyAttractor() 
  {
    int x;
    int y;
    int z;
    
    for (DeweySelection d : deweySelection)
    {
      if (d.id < 10)
      {
        x = 0;
        y = 0; 
        z = d.id;
      }
      else if(d.id >= 10 & d.id < 100)
      {
        String number = Integer.toString(d.id); 
        x = 0; 
        y = Integer.parseInt(number.substring(0,1)); 
        z = Integer.parseInt(number.substring(1,2));
      }
      else
      {
        String number = Integer.toString(d.id); 
        x = Integer.parseInt(number.substring(0,1)); 
        y = Integer.parseInt(number.substring(1,2)); 
        z = Integer.parseInt(number.substring(2,3));
      }
      
      Vector3D poc = new Vector3D(x*gridSize+gridSize,y*gridSize+gridSize,z*gridSize+gridSize);   
      DeweyDict dd = deweyDict.get(d.id);
      deweyAttractor.add(new DeweyAttractor(poc, col, dd));
    }
  }
  
  void render() 
  {
     for (int i = 0; i < deweyAttractor.size(); i++) 
     {
      DeweyAttractor p = (DeweyAttractor) deweyAttractor.get(i);  
      p.render();

      

    }   
  }
}

class DeweyAttractor 
{
  Vector3D loc;
  float radius;
  color col;
  DeweyDict deweyDict;
  
  // constructor
  DeweyAttractor(Vector3D l, color c, DeweyDict d) 
  {
    loc = l;
    col = c;
    deweyDict = d;
  }
  
  public DeweyDict getDeweyDict()
  {
    return deweyDict;
  }
  
  void render() 
  {  
    strokeWeight(lineweight*1.75);
    stroke(col);
    point(loc.x,loc.y,loc.z);
    // compute the mouse distance with the point
    float mouseObjectDistance = sq(mouseX-screenX(loc.x,loc.y,loc.z))+sq(mouseY-screenY(loc.x,loc.y,loc.z));
    // if the distance is smaller than a certain value
    if(mouseObjectDistance <20)
      {
        // add a bigger point
        strokeWeight(lineweight*5);
        point(loc.x,loc.y,loc.z);
        fill(col);
        // add text label
        textMode(SHAPE);
        // if the distance is close, make the textsize smaller
        if(cam.getDistance()<100){textSize(8);}
        // if the distance is far, make the textsize bigger
        else{textSize(12);}
        text(this.getDeweyDict().name,loc.x+2,loc.y+1.5,loc.z);
      }
  } 
}
